package com.bonus.sgzb.base.controller;

import com.bonus.sgzb.base.domain.BmUnitType;
import com.bonus.sgzb.base.service.IBmUnitTypeService;
import com.bonus.sgzb.common.core.utils.poi.ExcelUtil;
import com.bonus.sgzb.common.core.web.controller.BaseController;
import com.bonus.sgzb.common.core.web.domain.AjaxResult;
import com.bonus.sgzb.common.core.web.page.TableDataInfo;
import com.bonus.sgzb.common.log.annotation.Log;
import com.bonus.sgzb.common.log.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 单位类型bm_unit_type（同数据字典合并）Controller
 * 
 * @author gmh
 * @date 2023-12-11
 */
@Api(tags = "单位类型")
@RestController
@RequestMapping("/base/bmUnitType")
public class BmUnitTypeController extends BaseController
{
    @Autowired
    private IBmUnitTypeService bmUnitTypeService;

    /**
     * 查询单位类型bm_unit_type（同数据字典合并）列表
     */
    @ApiOperation("查询单位类型")
    @GetMapping("/list")
    public TableDataInfo list(BmUnitType bmUnitType)
    {
        startPage();
        List<BmUnitType> list = bmUnitTypeService.selectBmUnitTypeList(bmUnitType);
        return getDataTable(list);
    }
    /**
     * 查询单位类型bm_unit_type（同数据字典合并）列表
     */
    @ApiOperation("查询单位类型")
    @GetMapping("/typeList")
    public TableDataInfo selectTypeList(BmUnitType bmUnitType)
    {
        startPage();
        List<BmUnitType> list = bmUnitTypeService.selectTypeList(bmUnitType);
        return getDataTable(list);
    }
    /**
     * 导出单位类型bm_unit_type（同数据字典合并）列表
     */
    @ApiOperation("导出单位类型")
    @Log(title = "单位类型bm_unit_type（同数据字典合并）", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BmUnitType bmUnitType)
    {
        List<BmUnitType> list = bmUnitTypeService.selectBmUnitTypeList(bmUnitType);
        ExcelUtil<BmUnitType> util = new ExcelUtil<BmUnitType>(BmUnitType.class);
        util.exportExcel(response, list, "单位类型bm_unit_type（同数据字典合并）数据");
    }

    /**
     * 获取单位类型bm_unit_type（同数据字典合并）详细信息
     */
    @ApiOperation("获取单位类型")
    @GetMapping(value = "/{typeId}")
    public AjaxResult getInfo(@PathVariable("typeId") String typeId)
    {
        return success(bmUnitTypeService.selectBmUnitTypeByTypeId(typeId));
    }

    /**
     * 新增单位类型bm_unit_type（同数据字典合并）
     */
    @ApiOperation("新增单位类型")
    @Log(title = "单位类型bm_unit_type（同数据字典合并）", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody BmUnitType bmUnitType)
    {
        return toAjax(bmUnitTypeService.insertBmUnitType(bmUnitType));
    }

    /**
     * 修改单位类型bm_unit_type（同数据字典合并）
     */
    @ApiOperation("修改单位类型")
    @Log(title = "单位类型bm_unit_type（同数据字典合并）", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody BmUnitType bmUnitType)
    {
        return toAjax(bmUnitTypeService.updateBmUnitType(bmUnitType));
    }
    @ApiOperation("修改单位状态")
    @Log(title = "单位类型状态（同数据字典合并）", businessType = BusinessType.UPDATE)
    @GetMapping("/status/{typeId}")
    public AjaxResult update(@PathVariable String typeId)
    {
        return toAjax(bmUnitTypeService.update(typeId));
    }

    /**
     * 删除单位类型bm_unit_type（同数据字典合并）
     */
    @ApiOperation("删除单位类型")
    @Log(title = "单位类型bm_unit_type（同数据字典合并）", businessType = BusinessType.DELETE)
	@DeleteMapping("/{typeIds}")
    public AjaxResult remove(@PathVariable Long[] typeIds)
    {
        return toAjax(bmUnitTypeService.deleteBmUnitTypeByTypeIds(typeIds));
    }
}
